package net.moonleay.quickcrashreports.client.ui

import com.formdev.flatlaf.FlatDarculaLaf
import com.mashape.unirest.http.Unirest
import com.mashape.unirest.http.exceptions.UnirestException
import java.io.IOException

object CrashUi {
    fun start (crashReport: String) {
        println("Launching gui")
        FlatDarculaLaf.setup()
        JustCrashedGUI()
    }

    @Throws(IOException::class, InterruptedException::class, UnirestException::class)
    private fun sendPaste(text: String, burnAfterReading: Boolean): String {
        val body = StringBuilder("{\"text\": \"")
        body.append(text.replace("[\\u-0001-\\u001F]", "<br>")).append("\",\n")
        body.append("\"\"").append("\",\n")
        body.append("\"burn_after_reading\": ").append(burnAfterReading)
        body.append("}")

        Unirest.setTimeouts(-1, 0)
        val response = Unirest.post("https://bin.moonleay.net/")
            .header("Content-Type", "application/json")
            .body(body.toString())
            .asString()
        return response.body
    }
}
