package net.moonleay.quickcrashreports.mixin;

import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;
import com.mashape.unirest.http.exceptions.UnirestException;
import com.mojang.authlib.GameProfile;
import net.minecraft.client.MinecraftClient;
import net.minecraft.client.util.Session;
import net.minecraft.util.crash.CrashReport;
import net.moonleay.quickcrashreports.client.ui.LaunchGui;
import net.moonleay.quickcrashreports.client.util.RunJavaProcess;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Unique;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import java.io.IOException;

@Mixin(MinecraftClient.class)
public class IJustCrashedMixin {

    /* {
  "text": "<paste content>",
  "extension": "<file extension, optional>",
  "expires": <number of seconds from now, optional>,
  "burn_after_reading": <true/false, optional>
    }
*/
    @Inject(method = "printCrashReport", at = @At("HEAD"), cancellable = false)
    private static void POSTCrashReportToWastebin(CrashReport report, CallbackInfo ci) {
        System.out.println("[QCR] Your game crashed!!");

        StringBuilder sb = new StringBuilder();
        sb.append("== Game crashed! ==\n");
        sb.append("Details:\n");
        MinecraftClient mc = MinecraftClient.getInstance();
        Session currentSession = mc.getSession();
        GameProfile profile = currentSession.getProfile();
        sb.append("User: ").append(profile.getName()).append(", UUID: ").append(profile.getId().toString());
        sb.append("\nCrash Reason: ").append(report.getMessage());
        sb.append("\nComplete report:\n").append(report.asString());

        RunJavaProcess.runInNewProcess(LaunchGui.class, sb.toString());

        String response = null;
        try {
            response = sendPaste(sb.toString(), true);
        } catch (IOException | InterruptedException | UnirestException e) {
            throw new RuntimeException(e);
        }
        if (response == null)
            return;
//        String id = response.replaceAll("{\"path\":\"", "");
    }

    @Unique
    private static String sendPaste(String text, boolean burnAfterReading) throws IOException, InterruptedException, UnirestException {
        StringBuilder body = new StringBuilder("{\"text\": \"");
        body.append(text.replaceAll("[\\u0000-\\u001F]", "<br>")).append("\",\n");
//        body.append("\"\"").append("\",\n");
        body.append("\"burn_after_reading\": ").append(burnAfterReading);
        body.append("}");

        Unirest.setTimeouts(0, 0);
        HttpResponse<String> response = Unirest.post("https://bin.moonleay.net/")
                .header("Content-Type", "application/json")
                .body(body.toString())
                .asString();
        return response.getBody();
    }

}
